/*
   diag-c.h
   global declarations for the Diag routines in C
   this file is part of Diag
   last modified 19 Mar 10 th
*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include <complex.h>

typedef int Integer;
typedef const int cInteger;
typedef double Real;
typedef const Real cReal;
typedef double complex Complex;
typedef const Complex cComplex;

static inline Real csq(cComplex x) { return creal(x*conj(x)); }

static inline Real rsq(cReal x) { return x*x; }

static inline Real min(cReal a, cReal b) { return (a < b) ? a : b; }

static inline Real max(cReal a, cReal b) { return (a > b) ? a : b; }

static inline Integer imin(cInteger a, cInteger b) { return (a < b) ? a : b; }

static inline Integer imax(cInteger a, cInteger b) { return (a > b) ? a : b; }


Integer nsweeps;

#define Element(A,i,j) A[(i)*ld##A+(j)]


/* A matrix is considered diagonal if the sum of the squares
   of the off-diagonal elements is less than EPS.  SYM_EPS is
   half of EPS since only the upper triangle is counted for
   symmetric matrices.
   52 bits is the mantissa length for IEEE double precision. */

#define EPS 0x1p-102

#define SYM_EPS 0x1p-103

#define DBL_EPS 0x1p-52

